#include <IV-look/kit.h>
#include <InterViews/background.h>
#include <InterViews/image.h>
#include <InterViews/place.h>
#include <InterViews/session.h>
#include <InterViews/style.h>
#include <InterViews/tiff.h>
#include <InterViews/window.h>
#include <stdio.h>
#include <stdlib.h>

class App {
public:
    void msg();
};

declare(ActionCallback,App)
implement(ActionCallback,App)

void App::msg() {
    printf("hi mom!\n");
}

int main(int argc, char** argv) {
    Session* session = new Session("Himom", argc, argv);
    if (argc == 1) {
	fprintf(stderr, "Usage: %s <file>\n", argv[0]);
	exit(1);
    }
    Raster* rast = TIFFRaster::load(argv[1]);
    if (rast == nil) {
	fprintf(stderr, "%s: open tiff image %s failed\n", argv[0], argv[1]);
	exit(1);
    }

    Style* style = session->style();
    Kit* kit = Kit::instance();
    App* a = new App;
    session->run_window(
	new ApplicationWindow(
	    new Background(
		new Margin(
		    kit->push_button(
			new Image(rast), style,
			new ActionCallback(App)(a, &App::msg)
		    ),
		    10.0
		),
		style->flat()
	    )
	)
    );
}
